// This may look like C code, but it is really -*- Asm -*-
/*
 *  smoke16/src16/_udiv.s - Unsigned divide function.
 *  $Revision: 1.2 $
 *  Copyright 1997, 2000, Benjamin Sittler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#define SIGFPE 8 /* signal to raise on divide by zero */

	.text
	.align 1

	// _udiv -- divides the unsigned short in x (%a0) by the unsigned
	// short in y (%a1), placing the result in %a0.

	// the remainder is left in %a1
	
	// cause a "floating-point" exception when dividing by zero
fpe:	mov SIGFPE, %a0
	j _raise

	// short _udiv(short x, short y)
	.global __udiv
__udiv:	// check for division by 0
	cmpl %a1, %0
	be fpe
	// q = 0
	mov %0, %a2
	// check for x < y
	cmpl %a0, %a1
	bl udivN
udiv15:	// n = 15
	srl %a0, 15, %a3
	cmpl %a3, %a1
	bl udiv14
	add 1, %a2
	sll %a1, 15, %a3
	sub %a0, %a3, %a0
udiv14:	// n = 14
	sll %a2, 1, %a2
	srl %a0, 14, %a3
	cmpl %a3, %a1
	bl udiv13
	add 1, %a2
	sll %a1, 14, %a3
	sub %a0, %a3, %a0
udiv13:	// n = 13
	sll %a2, 1, %a2
	srl %a0, 13, %a3
	cmpl %a3, %a1
	bl udiv12
	add 1, %a2
	sll %a1, 13, %a3
	sub %a0, %a3, %a0
udiv12:	// n = 12
	sll %a2, 1, %a2
	srl %a0, 12, %a3
	cmpl %a3, %a1
	bl udiv11
	add 1, %a2
	sll %a1, 12, %a3
	sub %a0, %a3, %a0
udiv11:	// n = 11
	sll %a2, 1, %a2
	srl %a0, 11, %a3
	cmpl %a3, %a1
	bl udiv10
	add 1, %a2
	sll %a1, 11, %a3
	sub %a0, %a3, %a0
udiv10:	// n = 10
	sll %a2, 1, %a2
	srl %a0, 10, %a3
	cmpl %a3, %a1
	bl udiv9
	add 1, %a2
	sll %a1, 10, %a3
	sub %a0, %a3, %a0
udiv9:	// n = 9
	sll %a2, 1, %a2
	srl %a0, 9, %a3
	cmpl %a3, %a1
	bl udiv8
	add 1, %a2
	sll %a1, 9, %a3
	sub %a0, %a3, %a0
udiv8:	// n = 8
	sll %a2, 1, %a2
	srl %a0, 8, %a3
	cmpl %a3, %a1
	bl udiv7
	add 1, %a2
	sll %a1, 8, %a3
	sub %a0, %a3, %a0
	b udiv7
udivN:	// done
	mov %a0, %a1
	mov %a2, %a0
	ret
udiv7:	// n = 7
	sll %a2, 1, %a2
	srl %a0, 7, %a3
	cmpl %a3, %a1
	bl udiv6
	add 1, %a2
	sll %a1, 7, %a3
	sub %a0, %a3, %a0
udiv6:	// n = 6
	sll %a2, 1, %a2
	srl %a0, 6, %a3
	cmpl %a3, %a1
	bl udiv5
	add 1, %a2
	sll %a1, 6, %a3
	sub %a0, %a3, %a0
udiv5:	// n = 5
	sll %a2, 1, %a2
	srl %a0, 5, %a3
	cmpl %a3, %a1
	bl udiv4
	add 1, %a2
	sll %a1, 5, %a3
	sub %a0, %a3, %a0
udiv4:	// n = 4
	sll %a2, 1, %a2
	srl %a0, 4, %a3
	cmpl %a3, %a1
	bl udiv3
	add 1, %a2
	sll %a1, 4, %a3
	sub %a0, %a3, %a0
udiv3:	// n = 3
	sll %a2, 1, %a2
	srl %a0, 3, %a3
	cmpl %a3, %a1
	bl udiv2
	add 1, %a2
	sll %a1, 3, %a3
	sub %a0, %a3, %a0
udiv2:	// n = 2
	sll %a2, 1, %a2
	srl %a0, 2, %a3
	cmpl %a3, %a1
	bl udiv1
	add 1, %a2
	sll %a1, 2, %a3
	sub %a0, %a3, %a0
udiv1:	// n = 1
	sll %a2, 1, %a2
	srl %a0, 1, %a3
	cmpl %a3, %a1
	bl udiv0
	add 1, %a2
	sll %a1, 1, %a3
	sub %a0, %a3, %a0
udiv0:	// n = 0
	sll %a2, 1, %a2
	cmpl %a0, %a1
	bl udivN
	add 1, %a2
	sub %a0, %a1, %a0
	b udivN
