// This may look like C code, but it is really -*- Asm -*-
/*
 *  smoke16/src16/malloc.s - malloc() and friends.
 *  $Revision: 1.7 $
 *  Copyright 1997, Benjamin Sittler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <smoke16/asm.h>
	.data
freep:	.word 0 // free list pointer

	.lcomm base, 4 // first block

	.text
	.align 1
// char *sbrk(u16 nbytes)
	FUNCTION(_sbrk)
	push %t0
	mov %a0, %t0
	mov %0, %a0
	call _brk // brk(0) is a hack!
	add %a0, %t0, %a1
	mov %a0, %t0
	mov %a1, %a0
	call _brk
	mov -1, %a1
	cmpl %a0, %a1
	be sbrk0
	mov %t0, %a0
sbrk0:	pop %t0
	RET

#define NALLOC 256 /* minimum nblocks to request */
	
// char *morecore(u16 nblocks)
	FUNCTION(_morecore)
	mov NALLOC, %a1
	cmpl %a0, %a1
	bge morecore0
	mov %a1, %a0
morecore0:
	push %a0
	sll 2, %a0
	call _sbrk
	mov -1, %a1
	cmpl %a0, %a1
	be morecore1
	pop %a1
	mov %a1, [%a0 + 2]
	add 4, %a0
	call _free
	mov freep, %a0
	mov [%a0], %a0
	b morecore2
morecore1:
	pop
	mov %0, %a0
morecore2:
	RET

// void free(char *block)
	FUNCTION(_free)
	push %t0
	sub 4, %a0
	mov freep, %a1
	mov [%a1], %a2
free0:	mov [%a2], %a3
	cmpl %a0, %a2
	bl free1
	be free1
	cmpl %a0, %a3
	bge free1
	b free3
free1:	cmpl %a2, %a3
	bl free2
	cmpl %a0, %a2
	bg free3
	cmpl %a0, %a3
	bl free3
free2:	mov %a3, %a2
	b free0
free3:	mov [%a0 + 2], %t0
	add %a0, %t0
	cmpl %t0, %a3
	bne free4
	mov [%a3], %t0
	mov %t0, [%a0]
	mov [%a3 + 2], %t0
	mov [%a3 + 2], %a3
	add %a3, %t0
	mov %t0, [%a0 + 2]
	b free5
free4:	mov %a3, [%a0]
free5:	mov [%a2 + 2], %t0
	add %a2, %t0
	cmpl %t0, %a0
	bne free6
	mov [%a0], %t0
	mov %t0, [%a2]
	mov [%a2 + 2], %t0
	mov [%a0 + 2], %a0
	add %a0, %t0
	mov %t0, [%a2 + 2]
	b free7
free6:	mov %a0, [%a2]
free7:	mov %a2, [%a1]
	pop %t0
	RET

// char *malloc(u16 nbytes)
	FUNCTION(_malloc)
	push %t0
	mov freep, %t0
	add 7, %a0
	srl 2, %a0
	mov [%t0], %a1
	cmpl %0, %a1
	bne malloc0
	mov base, %a1
	mov %a1, [%a1]
	mov %a1, [%t0]
	mov %0, [%a1 + 2]
malloc0:
	mov [%a1], %a2
malloc1:
	mov [%a2 + 2], %a3
	cmpl %a3, %a0
	bl malloc4
	bne malloc2
	mov [%a2], %a3
	mov %a3, [%a1]
	b malloc3
malloc2:
	sub %a0, %a3
	mov %a3, [%a2 + 2]
	add %a3, %a2
	mov %a0, [%a2 + 2]
malloc3:
	mov %a1, [%t0]
	add 4, %a2
	mov %a2, %a0
	b mallocN
malloc4:
	mov [%t0], %a3
	cmpl %a2, %a3
	bne malloc5
	push %a0
	push %a1
	call _morecore
	pop %a1
	pop %a3
	cmpl %a0, %0
	be mallocN
	mov %a0, %a2
	mov %a3, %a0
malloc5:
	mov %a2, %a1
	mov [%a2], %a2
	b malloc1
mallocN:
	pop %t0 
	RET

